#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2


//----
extern string TimeFrame  = "Current time frame";
extern int Range         = 9;
extern int FastMA        = 2;
extern int SlowMA        = 30;
extern int filter        = 25;
extern int PriceMaPeriod = 5;
extern int PriceMaMethod = 1;
extern int PriceMaPrice  = PRICE_CLOSE;
//----
double Downa[];
double Downb[];
double Downhbu[];
double Downhbd[];
double trend[];
double fAMA[];
double mAMA[];
double AMA[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
   SetIndexBuffer(0, Downa);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, Downb);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, Downhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3, Downhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4, fAMA);
   SetIndexBuffer(5, trend); 
   SetIndexBuffer(6, mAMA);
   SetIndexBuffer(7, AMA);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         timeFrame         = stringToTimeFrame(TimeFrame);
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Downa[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Range,FastMA,SlowMA,filter,PriceMaPeriod,PriceMaMethod,PriceMaPrice,5,y);
                        if (trend[i]== 1) 
                        { 
                           Downa[i]   = High[i]; 
                           Downb[i]   = Low[i]; 
                           Downhbu[i] = MathMax(Open[i],Close[i]);
                           Downhbd[i] = MathMin(Open[i],Close[i]);
                        }
                        if (trend[i]==-1) 
                        { 
                           Downb[i]   = High[i]; 
                           Downa[i]   = Low[i]; 
                           Downhbu[i] = MathMin(Open[i],Close[i]);
                           Downhbd[i] = MathMax(Open[i],Close[i]);
                        }
               }
               return(0);
           }
   //int counted_bars = IndicatorCounted();
   int cb;
   double  k1, k2, Noise, ER, SSC, sdAMA, dAMA;
//----

       k1 = 2.0 / (SlowMA + 1);
       k2 = 2.0 / (FastMA + 1) - k1;
       //----
       for(cb = limit; cb >= 0; cb--)
         {
           Noise = 0;
           //----
           for(i = cb; i <= cb + Range - 1; i++)
             {
               Noise = Noise + MathAbs(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,i) - iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,i+1));
             }
           //----
           if(Noise != 0)
             {
               ER = MathAbs(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb) - iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb+Range)) / Noise;
             }
           else
             {
               ER = 0;
             }
           SSC = (ER*k2 + k1);
           AMA[cb] = AMA[cb+1] + NormalizeDouble(SSC*SSC*(iMA(NULL,0,PriceMaPeriod,0,PriceMaMethod,PriceMaPrice,cb) - AMA[cb+1]), 4);
           mAMA[cb] = AMA[cb];
           //----
           if(filter < 1)
             {
               fAMA[cb] = mAMA[cb];
             }
           else
             {
               for(i = cb; i <= cb + SlowMA - 1; i++)
                 {
                   sdAMA = sdAMA + MathAbs(mAMA[i] - mAMA[i+1]);
                 }
               dAMA = mAMA[cb] - mAMA[cb+1];
               //----
               if(dAMA >= 0)
                 {
                   if(dAMA < NormalizeDouble(filter*sdAMA / (100*SlowMA), 4) && 
                      High[cb] <= High[Highest(NULL, 0, MODE_HIGH, 4, cb)] + 10*Point)
                     {
                       fAMA[cb] = fAMA[cb+1];
                     }
                   else
                     {
                       fAMA[cb] = mAMA[cb];
                     }
                 }
               else
                 {
                   if(MathAbs(dAMA) < NormalizeDouble(filter*sdAMA / (100*SlowMA), 4) && 
                      Low[cb] > Low[Lowest(NULL, 0, MODE_LOW, 4, cb)] - 10*Point)
                     {
                       fAMA[cb] = fAMA[cb+1];
                     }
                   else
                     {
                       fAMA[cb] = mAMA[cb];
                     }
                 }
               sdAMA=0.0;
             }
         }
//----     

   for (i=limit; i>=0; i--)
   {
        trend[i] = trend[i+1];
           if (fAMA[i]> fAMA[i+1]) trend[i] =1;
           if (fAMA[i]< fAMA[i+1]) trend[i] =-1;
           if (trend[i]== 1) 
           { 
              Downa[i]   = High[i]; 
              Downb[i]   = Low[i]; 
              Downhbu[i] = MathMax(Open[i],Close[i]);
              Downhbd[i] = MathMin(Open[i],Close[i]);
           }
           if (trend[i]==-1) 
           { 
              Downb[i]   = High[i]; 
              Downa[i]   = Low[i]; 
              Downhbu[i] = MathMin(Open[i],Close[i]);
              Downhbd[i] = MathMax(Open[i],Close[i]);
           }
   }
   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(MathMax(Period(),StrToDouble(tfs)));
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}   