//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
//#property indicator_color5  RoyalBlue
//#property indicator_color6  Coral
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    UpBandPrice     = 0;    // Upper Band Price(ex.2 for High)     
extern int    LoBandPrice     = 0;    // Lower Band Price(ex.3 for Low) 
extern int    MA_Length       = 6;    // Bollinger Bands Period
extern int    MA_Mode         = 0;    // Mode of Moving Average  
extern double Deviation       = 1.0;
extern int    DeviationLength = 20;    // Period of Standard Deviation
extern double MoneyRisk       = 0.5; 

extern string _               = "alerts settings";
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;

//
//
//
//
//

double bbhu[];
double bbhd[];
double bbhbu[];
double bbhbd[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double bsmax[];
double bsmin[];
double trend[];
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
      SetIndexBuffer(0,bbhu);     SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,bbhd);     SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,bbhbu);    SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,bbhbd);    SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,UpArrow);  SetIndexStyle(4,DRAW_NONE); //SetIndexArrow(4,108);
      SetIndexBuffer(5,DnArrow);  SetIndexStyle(5,DRAW_NONE); //SetIndexArrow(5,108);
      SetIndexBuffer(6,smax);
      SetIndexBuffer(7,smin);
      SetIndexBuffer(8,bsmax);
      SetIndexBuffer(9,bsmin);
      SetIndexBuffer(10,trend);
      
      timeFrame = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+"BBands stop candles v3");
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
        double upMA     = iMA(NULL,timeFrame,MA_Length,0,MA_Mode,UpBandPrice,y);
        double dnMA     = iMA(NULL,timeFrame,MA_Length,0,MA_Mode,LoBandPrice,y);
        double upStdDev = iStdDev(NULL,timeFrame,DeviationLength,0,MA_Mode,UpBandPrice,y);
        double dnStdDev = iStdDev(NULL,timeFrame,DeviationLength,0,MA_Mode,LoBandPrice,y);
        double cl       = iClose(NULL,timeFrame,y);
               smax[i]  = upMA + (upStdDev*Deviation);
               smin[i]  = dnMA - (dnStdDev*Deviation);
               UpArrow[i] = EMPTY_VALUE;
               DnArrow[i] = EMPTY_VALUE;
               bbhu[i]    = EMPTY_VALUE;
               bbhd[i]    = EMPTY_VALUE;
               bbhbu[i]   = EMPTY_VALUE;
               bbhbd[i]   = EMPTY_VALUE;
               trend[i]   = trend[i+1]; 
   
               //
               //
               //
               //
               //
         
	            if (cl > smax[i+1]) trend[i]= 1; 
	            if (cl < smin[i+1]) trend[i]=-1;
	            if (trend[i] > 0 && smin[i] < smin[i+1]) smin[i] = smin[i+1];
	            if (trend[i] < 0 && smax[i] > smax[i+1]) smax[i] = smax[i+1];
	            bsmax[i] = smax[i]+0.5*(MoneyRisk-1)*(smax[i]-smin[i]);
	            bsmin[i] = smin[i]-0.5*(MoneyRisk-1)*(smax[i]-smin[i]);
	            if (trend[i] > 0 && bsmin[i] < bsmin[i+1]) bsmin[i] = bsmin[i+1];
	            if (trend[i] < 0 && bsmax[i] > bsmax[i+1]) bsmax[i] = bsmax[i+1];
               if (trend[i] == 1)
               {  
                  bbhu[i]  = High[i]; 
                  bbhd[i]  = Low[i];
                  bbhbu[i] = MathMax(Open[i],Close[i]);
                  bbhbd[i] = MathMin(Open[i],Close[i]); 
               }
               if (trend[i] ==-1)
               {  
                  bbhu[i]  = Low[i];
                  bbhd[i]  = High[i];
                  bbhbu[i] = MathMin(Open[i],Close[i]);
                  bbhbd[i] = MathMax(Open[i],Close[i]); 
               }
               
               //
               //
               //
               //
               //
            
               UpArrow[i] = EMPTY_VALUE;
               DnArrow[i] = EMPTY_VALUE;
               if (trend[i]!= trend[i+1])
               if (trend[i] == 1)
                     UpArrow[i] = Low[i]  - iATR(NULL,0,20,i)/2;
               else  DnArrow[i] = High[i] + iATR(NULL,0,20,i)/2;
      }
      manageAlerts();
      return(0);
 }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" bollinger bands stop ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," bollinger bands stop "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}




