//------------------------------------------------------------------
#property copyright "thefxpros"
#property link      "thefxpros@katamail.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color5  Black
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2


//
//
//
//
//
extern int    Nbars           = 500;
extern int    TimeFrame       = 0;
extern int    CCIPeriod       = 9;
extern int    CCIPrice        = PRICE_CLOSE;
extern int    AvgPeriod       = 9;
extern int    AvgMethod       = 1;
extern double OverSold        = 0;
extern double OverBought      = 0;
 
extern color  WickUpColor     = DarkGreen;
extern color  WickDnColor     = FireBrick;
extern color  BodyUpColor     = LimeGreen;
extern color  BodyDnColor     = Orange;

extern int    WickWidth       = 1;
extern int    BodyWidth       = 2;


//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double UpbBuffer[];
double DnbBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int init()
{
   SetIndexBuffer(0,UpBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, WickWidth, WickUpColor);  
   SetIndexBuffer(1,DnBuffer);  SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, WickWidth, WickDnColor); 
   SetIndexBuffer(2,UpbBuffer); SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyUpColor);  
   SetIndexBuffer(3,DnbBuffer); SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyDnColor); 
      
   
   IndicatorShortName("CCI pre-filtered candles ("+CCIPeriod+","+AvgPeriod+","+AvgMethod+")");
   
   return(0);

  }


 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);

   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int slope=iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,6,y);
         if (slope ==  1) { UpBuffer[i]=High[i]; DnBuffer[i]=Low[i]; UpbBuffer[i] = MathMax(Open[i],Close[i]); DnbBuffer[i] = MathMin(Open[i],Close[i]); }
         if (slope == -1) { DnBuffer[i]=High[i]; UpBuffer[i]=Low[i]; DnbBuffer[i] = MathMax(Open[i],Close[i]); UpbBuffer[i] = MathMin(Open[i],Close[i]); }
   
   

   }   
   return(0);
  }
//+------------------------------------------------------------------+  
  