//------------------------------------------------------------------
#property copyright "thefxpros"
#property link      "thefxpros@katamail.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color5  Black
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  1

//
//
//
extern int    Nbars           = 500;
extern int    TimeFrame       = 0;
extern int    CCIPeriod       = 9;
extern int    CCIPrice        = PRICE_CLOSE;
extern int    AvgPeriod       = 9;
extern int    AvgMethod       = 1;
extern double OverSold        = 0;
extern double OverBought      = 0;
extern color  OverSoldColor   = LimeGreen; 
extern color  OverBoughtColor = DarkOrange; 
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//

double cci[];
double cciUpa[];
double cciUpb[];
double cciDna[];
double cciDnb[];
double prices[];
double trend[];
double slope[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int init()
{
     IndicatorBuffers(8);
      SetIndexBuffer(0,cciUpa); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY,OverSoldColor);
      SetIndexBuffer(1,cciUpb); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,EMPTY,OverSoldColor);
      SetIndexBuffer(2,cciDna); SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,EMPTY,OverBoughtColor);
      SetIndexBuffer(3,cciDnb); SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,EMPTY,OverBoughtColor);
      SetIndexBuffer(4,cci);
      SetIndexBuffer(5,prices);
      SetIndexBuffer(6,trend);
      SetIndexBuffer(7,slope);
      
      
   
     IndicatorShortName("CCI pre-filtered histo MTF ("+CCIPeriod+","+AvgPeriod+","+AvgMethod+")");
   
   return(0);

   


   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("CCI pre-filtered histo MTF ("+TimeFrameStr+")");
   return(0);

  }

//----

   
 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
{
   int limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           if (Nbars<=0) Nbars = Bars-1;
            limit=MathMin(MathMin(Bars-counted_bars,Bars-1),Nbars);

   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      
      cci [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,4,y);
   cciUpa [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,0,y);
   cciUpb [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,1,y);
   cciDna [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,2,y);
   cciDnb [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,3,y);
   prices [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,5,y);
   trend  [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,6,y);
   slope  [i] = iCustom(Symbol(),TimeFrame,"CCI pre-filtered histo",Nbars,CCIPeriod,CCIPrice,AvgPeriod,AvgMethod,OverSold,OverBought,OverSoldColor,OverBoughtColor,7,y);
   
   }   
   return(0);
  }
//+------------------------------------------------------------------+  
  