#property copyright "MA . +MA.mq4 2.0.  2008-2012 Plus"
#property link      "http://fxcoder.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Crimson
#property indicator_color2 C'165,15,45'
#property indicator_color3 C'110,10,30'
#property indicator_color4 C'55,5,15'

/*   */
extern int MAPeriod = 20;                   //  MA
extern int MAMethod = MODE_SMA;             //  
extern int TimeFrame = 0;                   //  , 0 - 
extern bool Interpolate = false;            // : false -   , true - 
extern int AppliedPrice = PRICE_CLOSE;      //   

/*  */
extern color LineColor = Crimson;           //  
extern color TouchColor = CLR_NONE;         //  
extern int LineStyle = STYLE_SOLID;         //  
extern int LineWidth = 2;                   //   (    STYLE_SOLID)
extern int TouchDistance = 300;             //  , 0 - 

double MA1[], MA2[], MA3[], MA4[];
int mc = 4;
int maPeriod;
int tf;

int init()
{
	tf = Ifi(TimeFrame > 0, TimeFrame, Period());

	maPeriod = MAPeriod * tf / Period();

	int db = MAPeriod;
	if (Interpolate)
		db = maPeriod;

	SetIndexBuffer(0, MA1);
	SetIndexBuffer(1, MA2);
	SetIndexBuffer(2, MA3);
	SetIndexBuffer(3, MA4);

	string mas = MAMethodToString(MAMethod);
	string l = mas + MAPeriod + "@" + PeriodToStr(tf) + Ifs(Interpolate, " (~" + mas + maPeriod + ")");
	for (int i = 0; i < mc; i++)
	{
		SetIndexDrawBegin(i, db);
		SetIndexLabel((mc - 1) - i, l);
	}

	IndicatorShortName(WindowExpertName() + ": " + l);

	updateColors();

	return(0);
}

int start()
{
	//       
	if (Interpolate && (Bars - maPeriod - 1 < 1))
		return(0);

	//    
	if (!Interpolate && tf < Period())
		return(0);

	//       
	if (Interpolate && (tf > 1440 || Period() > 1440))
		return(0);

	int counted_bars = IndicatorCounted();
	if (counted_bars > 0)
		counted_bars--;
	int barsToCalc = Bars - counted_bars;

	if (!Interpolate)
		barsToCalc = MathMax(barsToCalc, TimeFrame / Period());

	//       (   )
	barsToCalc = MathMin(barsToCalc + 1, Bars);

	updateColors();

	double ma, ma1;

	//
	for (int i = barsToCalc - 1; i >= 0 ; i--)
	{
		MA1[i] = EMPTY_VALUE;
		MA2[i] = EMPTY_VALUE;
		MA3[i] = EMPTY_VALUE;
		MA4[i] = EMPTY_VALUE;

		if (Interpolate)
		{
			ma = iMA(NULL, 0, maPeriod, 0, MAMethod, AppliedPrice, i);
			ma1 = iMA(NULL, 0, maPeriod, 0, MAMethod, AppliedPrice, i + 1);
		}
		else
		{
			datetime time0 = iTime(NULL, 0, i);
			datetime time1 = iTime(NULL, 0, i + 1);
			int j0 = iBarShift(NULL, TimeFrame, time0);
			int j1 = iBarShift(NULL, TimeFrame, time1);

			ma = iMA(NULL, TimeFrame, MAPeriod, 0, MAMethod, AppliedPrice, j0);
			ma1 = iMA(NULL, TimeFrame, MAPeriod, 0, MAMethod, AppliedPrice, j1);
		}

		MA1[i] = ma;

		//     
		double distance = MathMin(MathAbs(ma - High[i]), MathAbs(Low[i] - ma)) / Point;

		if (TouchDistance > 0)
		{
			if (High[i] >= ma && Low[i] <= ma)
				distance = 0;

			if (distance < 2 * TouchDistance)
			{
				MA2[i] = ma;
				MA2[i+1] = ma1;
			}

			if (distance < 1 * TouchDistance)
			{
				MA3[i] = ma;
				MA3[i+1] = ma1;
			}

			if (distance == 0)
			{
				MA4[i] = ma;
				MA4[i+1] = ma1;
			}
		}
	}

	return(0);
}

void updateColors()
{
	color freeColor = LineColor;
	color touchColor = TouchColor;

	if (ColorIsNone(freeColor))
		freeColor = GetBGColor();

	if (ColorIsNone(touchColor))
		touchColor = GetBGColor();

	for (int i = 0; i < mc; i++)
		SetIndexStyle(i, DRAW_LINE, LineStyle, LineWidth, MixColors(freeColor, touchColor, 1.0 * i / mc, 1));
}

#import "user32.dll"
int GetWindowDC(int h);
int ReleaseDC(int h, int hDC);

#import "gdi32.dll"
int GetPixel(int hDC, int x, int y);
#import

//    
color GetBGColor()
{
	color bgColor = CLR_NONE;

	int h = WindowHandle(Symbol(), Period());
	if (h != 0)
	{
		//     .
		int hDC = GetWindowDC(h);

		//    ,   
		int c1 = GetPixel(hDC, 3, 10); // 
		int c2 = GetPixel(hDC, 4, 10); // 
		int c3 = GetPixel(hDC, 5, 10); // 

		//   ,     ( )
		if (c1 != c2 && c1 == c3)
			bgColor = c1;

		ReleaseDC(h, hDC);
	}

	return(bgColor);
}

//    None ( -  4)
bool ColorIsNone(color c)
{
	return((c == CLR_NONE) || (c == -16777216));
}

//    
void ColorToRGB(color c, int& r, int& g, int& b)
{
	b = (c & 0xFF0000) >> 16;
	g = (c & 0x00FF00) >> 8;
	r = (c & 0x0000FF);
}

//    
color RGBToColor(int r, int g, int b)
{
	return((b << 16) + (g << 8) + r);
}

//  
// mix = 0..1
color MixColors(color color1, color color2, double mix, int step = 16)
{
	if (step <= 0)
		step = 1;

	int r1, g1, b1;
	int r2, g2, b2;

	//   
	ColorToRGB(color1, r1, g1, b1);
	ColorToRGB(color2, r2, g2, b2);

	// 
	int r = MathMax(MathMin(r1 + mix * (r2 - r1), 255), 0) / step;
	int g = MathMax(MathMin(g1 + mix * (g2 - g1), 255), 0) / step;
	int b = MathMax(MathMin(b1 + mix * (b2 - b1), 255), 0) / step;

	r *= step;
	g *= step;
	b *= step;

	return(RGBToColor(r, g, b));
}

//      
string PeriodToStr(int period = 0)
{
	if (period == 0)
		period = Period();

	if (period < PERIOD_H1)
		return(StringConcatenate("M", period));
	else if (period < PERIOD_D1 && period % 60 == 0)
		return(StringConcatenate("H", period / 60));
	else if (period < PERIOD_W1 && period % 1440 == 0)
		return(StringConcatenate("D", period / 1440));
	else if (period == PERIOD_MN1 && period % 10080 == 0)
		return(StringConcatenate("W", period / 10080));
	else if (period == PERIOD_MN1)
		return("MN1");
	else
		return(StringConcatenate("M", period));
}

//   ,  i1,  i2
int Ifi(bool c, int i1, int i2)
{
	if (c)
		return(i1);
	else
		return(i2);
}

//   ,  s1,  s2
string Ifs(bool c, string s1, string s2 = "")
{
	if (c)
		return(s1);
	else
		return(s2);
}

string MAMethodToString(int mm)
{
	switch (mm)
	{
		case MODE_SMA: return("SMA");
		case MODE_EMA: return("MA");
		case MODE_SMMA: return("SMMA");
		case MODE_LWMA: return("LWMA");
		default: return("MA(type " + mm +")");
	}
}

// 2012-04-22 09:34:41 UTC
// MQLMake 1.17.0. Copyright  Plus 2011-2012. http://fxcoder.ru