//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DarkGreen
#property indicator_color2  Maroon
#property indicator_color3  Chartreuse
#property indicator_color4  Crimson
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    MA1Period = 3;
extern int    MA1Method = MODE_EMA;
extern int    MA1Price  = PRICE_CLOSE;
extern int    MA2Period = 8;
extern int    MA2Method = MODE_EMA;
extern int    MA2Price  = PRICE_CLOSE;
extern int    Nbars     = 200;

//
//
//
//
//

double mahu[];
double mahd[];
double mahbu[];
double mahbd[];
double trend[];
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,mahu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,mahd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,mahbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,mahbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,trend); 
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+"MA - ribbon filled MTF candles");

return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit=MathMax(Nbars-counted_bars,3*timeFrame/Period());

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double fastMa = iMA(NULL,timeFrame,MA1Period,0,MA1Method,MA1Price,y);
      double slowMa = iMA(NULL,timeFrame,MA2Period,0,MA2Method,MA2Price,y);
      trend[i] = trend[i+1];
         if(fastMa>slowMa) trend[i] = 1;
         if(fastMa<slowMa) trend[i] =-1;
         if (trend[i]== 1)
         {
            mahu[i]  = High[i]; 
            mahd[i]  = Low[i];
            mahbu[i] = MathMax(Open[i],Close[i]);
            mahbd[i] = MathMin(Open[i],Close[i]);
         }               
         if (trend[i]== -1)
         {
            mahu[i]  = Low[i];
            mahd[i]  = High[i];
            mahbu[i] = MathMin(Open[i],Close[i]);
            mahbd[i] = MathMax(Open[i],Close[i]);
         }               
      
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(StrToInteger(tfs));
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

