//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DarkGreen
#property indicator_color2 Crimson
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern int       NBars     = 250; 
extern int       TimeFrame = 3;
extern int       MA1Period = 5;
extern int       MA1Method = MODE_EMA;
extern int       MA1Price  = PRICE_CLOSE;
extern int       MA2Period = 12;
extern int       MA2Method = MODE_EMA;
extern int       MA2Price  = PRICE_CLOSE;
extern color     ColorUp   = C'198,255,198';
extern color     ColorDown = C'255,198,198';
extern int       FillWidth = 3;
extern string    UniqueID  = "MA - ribbon filled MTF sw coloured";

//
//
//
//
//

double buffer1[];
double buffer2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
      TimeFrame = MathMax(TimeFrame,Period());
      IndicatorShortName(UniqueID);
   return(0);
}
int deinit()
{
   string lookFor = UniqueID+":";
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringFind(name,lookFor) > -1) ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit= MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);
         int window = WindowFind(UniqueID);

   //
   //
   //
   //
   //

   for(int i=NBars; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      buffer1[i] = iMA(NULL,TimeFrame,MA1Period,0,MA1Method,MA1Price,y);
      buffer2[i] = iMA(NULL,TimeFrame,MA2Period,0,MA2Method,MA2Price,y);
      string name = UniqueID+":"+Time[i];
         ObjectCreate(name,OBJ_TREND,window,0,0,0,0);
            ObjectSet(name,OBJPROP_TIME1,Time[i]);
            ObjectSet(name,OBJPROP_TIME2,Time[i]);
            ObjectSet(name,OBJPROP_PRICE1,buffer1[i]);
            ObjectSet(name,OBJPROP_PRICE2,buffer2[i]);
            ObjectSet(name,OBJPROP_BACK,true);
            ObjectSet(name,OBJPROP_RAY,false);
            ObjectSet(name,OBJPROP_WIDTH,FillWidth);
            if (buffer1[i]>buffer2[i])
                  ObjectSet(name,OBJPROP_COLOR,ColorUp);
            else  ObjectSet(name,OBJPROP_COLOR,ColorDown);
   }
   return(0);
}

