//+------------------------------------------------------------------+
//|                                    Macd_with_EMA_BDv09_12_22.mq4 |
//|                                                             Jeff |
//|                                                  wolfboy@att.net |
//+------------------------------------------------------------------+

#property copyright "Jeff"
#property link      "wolfboy@att.net"



#property indicator_separate_window
#property indicator_buffers 7

#property indicator_color1 LimeGreen
#property indicator_color2 LimeGreen
#property indicator_color3 Plum
#property indicator_color4 Plum
#property indicator_color5 CLR_NONE
#property indicator_color6 Black
#property indicator_color7 CLR_NONE

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 2

#property indicator_level1 0.0
#property indicator_levelcolor DimGray
#property indicator_levelstyle 0



//---- indicator parameters

extern int Nbars         = 500;
extern int TimeFrame     = 0;
extern int FastEMA       = 10;
extern int SlowEMA       = 20;
extern int SignalEMA     = 1;
extern int MAofSignalPer = 7;


//---- indicator buffers

double green_buffer[];
double DarkGreen_buffer[];
double red_buffer[];
double Maroon_buffer[];
double MacdBuffer[];
double SignalBuffer[];
double MAofSignalBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  
  
  //---- indicator buffers mapping

   SetIndexBuffer(0,green_buffer);
   SetIndexBuffer(1,DarkGreen_buffer);
   SetIndexBuffer(2,red_buffer);
   SetIndexBuffer(3,Maroon_buffer);
   SetIndexBuffer(4,MacdBuffer);      
   SetIndexBuffer(5,SignalBuffer);
   SetIndexBuffer(6,MAofSignalBuffer);
   
   
  //---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);         
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
      
   SetIndexDrawBegin(1,SignalEMA);
   IndicatorDigits(Digits+1);  

   IndicatorShortName("MACD in color MTF ("+FastEMA+","+SlowEMA+","+SignalEMA+","+MAofSignalPer+")");
      
   
   
   switch(TimeFrame)
   {
   case 1: string TimeFrameStr = "M1" ;  break;
   case 5     :   TimeFrameStr = "M5" ;  break;
   case 15    :   TimeFrameStr = "M15";  break;
   case 30    :   TimeFrameStr = "M30";  break;
   case 60    :   TimeFrameStr = "H1" ;  break;
   case 240   :   TimeFrameStr = "H4" ;  break;
   case 1440  :   TimeFrameStr = "D1" ;  break;
   case 10080 :   TimeFrameStr = "W1" ;  break;
   case 43200 :   TimeFrameStr = "MN1";  break;
   default :      TimeFrameStr = "TF0";
   
  }
   IndicatorShortName("MACD in color MTF ("+TimeFrameStr+","+FastEMA+","+SlowEMA+","+SignalEMA+","+MAofSignalPer+")");
   return(0);

  }



//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           if (Nbars<=0) Nbars = Bars-1;
            limit=MathMin(MathMin(Bars-counted_bars,Bars-1),Nbars);
           
   if (TimeFrame != Period())
   {
      limit = MathMax(limit,TimeFrame/Period());
      for(i = 0; i < limit; i++)
      {
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         
            green_buffer[i]      = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,0,y);
            DarkGreen_buffer[i]  = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,1,y);
            red_buffer[i]        = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,2,y);
            Maroon_buffer[i]     = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,3,y);
            MacdBuffer[i]        = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,4,y);             
            SignalBuffer[i]      = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,5,y); 
            MAofSignalBuffer[i]  = iCustom(Symbol(),TimeFrame,"MACD in color",Nbars,FastEMA,SlowEMA,SignalEMA,MAofSignalPer,6,y);
            
                       
      }
   return(0);         
  } 
  }      