//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Orange
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  LimeGreen
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//
extern int     Nbars     = 500;
extern string  TimeFrame = "Current time frame";
extern int     Length    = 14;
extern int     Price     = PRICE_CLOSE;
extern double  Lambda    = 5;
extern bool   alertsOn          = false;
extern bool   alertsOnCurrent   = false;
extern bool   alertsMessage     = false;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;

//
//
//
//
//

double mom[];
double rema[];
double huu[];
double hud[];
double hdd[];
double hdu[];
double slope[];
double trend[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,hud); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,huu); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,hdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,mom);
      SetIndexBuffer(5,rema);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,trend);
         timeFrame           = stringToTimeFrame(TimeFrame);
         indicatorFileName   = WindowExpertName();
         returnBars          = TimeFrame=="returnBars"; if (returnBars) return(0);
         IndicatorShortName(timeFrameToString(timeFrame)+"Momentum MTF candles ("+Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           if (Nbars<=0) Nbars = Bars-1;
            limit=MathMin(MathMin(Bars-counted_bars,Bars-1),Nbars);
           
         if (returnBars) { huu[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
                  mom[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",Length,Price,Lambda,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
                  slope[i] = slope[i+1];
                  trend[i] = trend[i+1];
                  huu[i]   = EMPTY_VALUE;
                  hud[i]   = EMPTY_VALUE;
                  hdd[i]   = EMPTY_VALUE;
                  hdu[i]   = EMPTY_VALUE;
                     if (mom[i] > 0) trend[i] =  1;
                     if (mom[i] < 0) trend[i] = -1;
                     if (trend[i]== 1) { huu[i] = High[i]; hud[i] = Low[i]; hdu[i] = MathMax(Open[i],Close[i]); hdd[i] = MathMin(Open[i],Close[i]); }
                     if (trend[i]==-1) { hud[i] = High[i]; huu[i] = Low[i]; hdd[i] = MathMax(Open[i],Close[i]); hdu[i] = MathMin(Open[i],Close[i]); }
            }       
            return(0);
         }

   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0*Length);      
   double regf1 = (1.0+Lambda*2.0);
   double regf2 = (1.0+Lambda);
   for(i=limit; i>=0; i--) 
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (Bars-i>1)
            rema[i] = (regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2;
      else  rema[i] = price;
      mom[i] = (rema[i]-rema[i+1])/rema[i];
         trend[i] = trend[i+1];
         huu[i]   = EMPTY_VALUE;
         hud[i]   = EMPTY_VALUE;
         hdd[i]   = EMPTY_VALUE;
         hdu[i]   = EMPTY_VALUE;
            if (mom[i] > 0) trend[i] =  1;
            if (mom[i] < 0) trend[i] = -1;
            if (trend[i]== 1) { huu[i] = High[i]; hud[i] = Low[i]; hdu[i] = MathMax(Open[i],Close[i]); hdd[i] = MathMin(Open[i],Close[i]); }
            if (trend[i]==-1) { hud[i] = High[i]; huu[i] = Low[i]; hdd[i] = MathMax(Open[i],Close[i]); hdu[i] = MathMin(Open[i],Close[i]); }
   }      
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up"  );
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Regularized momentum crossed 0 ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Regularized momentum "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
