//+------------------------------------------------------------------+
//|                                 Step chart age 2 MTF candles.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+

#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 4

#property indicator_color1 DarkGreen
#property indicator_color2 FireBrick
#property indicator_color3 LimeGreen
#property indicator_color4 Orange

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2


//---- input parameters

extern int     TimeFrame      =   0;   //TimeFrame in min 
extern int     Price          =   0;   //Applied to (0...6)
extern double  StepSize       =   2;   //Size in pips
extern int     HiLoMode       =   0;   //High/Low Mode:0-off,1-on
extern int     VoltyLength    =   0;   //Volty Length(0-will be used StepSize)
extern double  VoltyRatio     =   1;   //Volty Ratio
extern double  Multiplier     =   2;   //Reversal Multiplier 
extern int     PreSmooth      =   1;   //Pre-smoothing Length 
extern int     PreSmoothMode  =   3;   //Pre-smoothing Method  
extern int     StartPriceMode =   0;   //Start Price Mode: 0-as is,1-rounded to StepSize  

extern color   WickUpColor        = DarkGreen;
extern color   WickDnColor        = FireBrick;
extern color   BodyUpColor        = LimeGreen;
extern color   BodyDnColor        = Orange;

extern int     WickWidth          = 1;
extern int     BodyWidth          = 2;


double UpWickBuffer[];
double DnWickBuffer[];
double UpBodyBuffer[];
double DnBodyBuffer[];


int init()
{
   SetIndexBuffer(0,UpWickBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, WickWidth, WickUpColor);  
   SetIndexBuffer(1,DnWickBuffer);  SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, WickWidth, WickDnColor); 
   SetIndexBuffer(2,UpBodyBuffer);  SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyUpColor);  
   SetIndexBuffer(3,DnBodyBuffer);  SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyDnColor); 
         
   IndicatorShortName("Step chart age 2 MTF candles ("+Price+","+StepSize+","+VoltyRatio+","+Multiplier+")");
         


   switch(TimeFrame)
   {
      case 1: string TimeFrameStr="Period_M1";  break;
      case 5:        TimeFrameStr="Period_M5";  break;
      case 15:       TimeFrameStr="Period_M15"; break;
      case 30:       TimeFrameStr="Period_M30"; break;
      case 60:       TimeFrameStr="Period_H1";  break;
      case 240:      TimeFrameStr="Period_H4";  break;
      case 1440:     TimeFrameStr="Period_D1";  break;
      case 10080:    TimeFrameStr="Period_W1";  break;
      case 43200:    TimeFrameStr="Period_MN1"; break;
      default:       TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("Step chart age 2 MTF candles ("+TimeFrameStr+","+Price+","+StepSize+","+VoltyRatio+","+Multiplier+")");
   return(0);

  }

//----  


//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);

   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int trend = iCustom(Symbol(),TimeFrame,"Step chart age 2 MTF",0,Price,StepSize,HiLoMode,VoltyLength,VoltyRatio,Multiplier,PreSmooth,PreSmoothMode,StartPriceMode,2,y);
         if (trend > 0) { UpWickBuffer[i]=High[i]; DnWickBuffer[i]=Low[i]; UpBodyBuffer[i] = MathMax(Open[i],Close[i]); DnBodyBuffer[i] = MathMin(Open[i],Close[i]); }
         if (trend < 0) { DnWickBuffer[i]=High[i]; UpWickBuffer[i]=Low[i]; DnBodyBuffer[i] = MathMax(Open[i],Close[i]); UpBodyBuffer[i] = MathMin(Open[i],Close[i]); }
   
   

   }   
   return(0);
  }
//+------------------------------------------------------------------+  
  