//+------------------------------------------------------------------+
//|                                                    StepMA v9.mq4 |
//|                             Copyright  2007-13, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-13, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkGreen
#property indicator_width1 1
#property indicator_color2 FireBrick
#property indicator_width2 1
#property indicator_color3 LimeGreen
#property indicator_width3 2
#property indicator_color4 Orange
#property indicator_width4 2



//---- input parameters


extern int     TimeFrame         =     0;    //TimeFrame in min
extern int     Price             =     0;    //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted)
extern int     Length            =     5;    //Length of evaluation
extern double  StepSize          =     0;    //Constant Step Size in pips 
extern double  Multiplier        =     2.55;    //Volatility's Factor or Multiplier
extern double  MinStep           =     0.25;    //Min Step in pips 
extern int     Displace          =     0;    //DispLace or Shift in bars
extern int     ColorMode         =     1;    //Switch of Color mode (1-color)  
extern int     StepMAMode        =     0;    //StepMA Mode: 0-new,1-old

extern color   WickUpColor        = DarkGreen;
extern color   WickDnColor        = FireBrick;
extern color   BodyUpColor        = LimeGreen;
extern color   BodyDnColor        = Orange;

extern int     WickWidth          = 1;
extern int     BodyWidth          = 2;  

/*
extern string  alerts            = "--- Alerts & E-Mails ---";
extern int     AlertMode         =     0;    //Alert mode: 0-off,1-on
extern int     SoundsNumber      =     5;    //Number of sounds after Signal
extern int     SoundsPause       =     5;    //Pause in sec between sounds 
extern string  UpSound           = "alert.wav";
extern string  DnSound           = "alert2.wav";
extern int     EmailMode         =     0;    //0-on,1-off   
extern int     EmailsNumber      =     1;    //0-on,1-off
*/

double UpWickBuffer[];
double DnWickBuffer[];
double UpBodyBuffer[];
double DnBodyBuffer[];

int init()
{
   SetIndexBuffer(0,UpWickBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, WickWidth, WickUpColor);  
   SetIndexBuffer(1,DnWickBuffer);  SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, WickWidth, WickDnColor); 
   SetIndexBuffer(2,UpBodyBuffer); SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyUpColor);  
   SetIndexBuffer(3,DnBodyBuffer); SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, BodyWidth, BodyDnColor); 
      
   
   IndicatorShortName("StepMA 9 MTF candles ("+Length+","+StepSize+","+Multiplier+","+MinStep+")");
      Length = MathMax(Length,1);
   


   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("StepMA 9 MTF candles ("+TimeFrameStr+")");
   return(0);

  }

//----

   
 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/Period()),Bars-1);

   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int slope=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,3,y);
         if (slope ==  1) { UpWickBuffer[i]=High[i]; DnWickBuffer[i]=Low[i]; UpBodyBuffer[i] = MathMax(Open[i],Close[i]); DnBodyBuffer[i] = MathMin(Open[i],Close[i]); }
         if (slope == -1) { DnWickBuffer[i]=High[i]; UpWickBuffer[i]=Low[i]; DnBodyBuffer[i] = MathMax(Open[i],Close[i]); UpBodyBuffer[i] = MathMin(Open[i],Close[i]); }
   
   

   }   
   return(0);
  }
//+------------------------------------------------------------------+  
  