//+------------------------------------------------------------------+
//|                                                    StepMA_v9.mq4 |
//|                             Copyright  2007-13, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-13, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  OrangeRed
#property indicator_width1  2  
#property indicator_color2  DeepSkyBlue
#property indicator_width2  2  
#property indicator_color3  DeepSkyBlue
#property indicator_width3  2  



//---- input parameters

extern int     TimeFrame         =     0;    //TimeFrame in min
extern int     Price             =     0;    //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted)
extern int     Length            =     5;    //Length of evaluation
extern double  StepSize          =     0;    //Constant Step Size in pips 
extern double  Multiplier        =     2;    //Volatility's Factor or Multiplier
extern double  MinStep           =     0;    //Min Step in pips 
extern int     Displace          =     0;    //DispLace or Shift in bars
extern int     ColorMode         =     1;    //Switch of Color mode (1-color)  
extern int     StepMAMode        =     0;    //StepMA Mode: 0-new,1-old  

extern string  alerts            = "--- Alerts & E-Mails ---";
extern int     AlertMode         =     0;    //Alert mode: 0-off,1-on
extern int     SoundsNumber      =     5;    //Number of sounds after Signal
extern int     SoundsPause       =     5;    //Pause in sec between sounds 
extern string  UpSound           = "alert.wav";
extern string  DnSound           = "alert2.wav";
extern int     EmailMode         =     0;    //0-on,1-off   
extern int     EmailsNumber      =     1;    //0-on,1-off


//---- indicator buffers
double Line[];
double upTrend1[];
double upTrend2[];
double trend[];



int init()
{

  IndicatorBuffers(4);
   
   SetIndexBuffer(0,    Line); SetIndexStyle(0,DRAW_LINE);  
   SetIndexBuffer(1,upTrend1); SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,upTrend2); SetIndexStyle(2,DRAW_LINE);  
   SetIndexBuffer(3,   trend);
   
   IndicatorShortName("StepMA 9 MTF sw ("+Length+","+StepSize+","+Multiplier+","+MinStep+")");
      Length = MathMax(Length,1);
   
   
    switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("StepMA 9 MTF sw ("+TimeFrameStr+","+Length+","+StepSize+","+Multiplier+","+MinStep+")");
   return(0);
   
   
  }

//----

   
 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= MathMin(Bars-counted_bars+3*TimeFrame/Period(),Bars-1);
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
   

/*********************************************************************************************************
   Add your main indicator loop below. You can reference an existing indicator with its iName or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 ********************************************************************************************************/ 
  
 
   Line[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,0,y);
   upTrend1[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,1,y); 
   upTrend2[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,2,y);
   //smin[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,3,y);
   //smax[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,4,y);
   //trend[i]=iCustom(Symbol(),TimeFrame,"StepMA 9",TimeFrame,Price,Length,StepSize,Multiplier,MinStep,Displace,ColorMode,StepMAMode,5,y);
   
   

   }   
   return(0);
  }
//+------------------------------------------------------------------+
