//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property  copyright "www.forex-tsd.com"
#property  link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  DeepSkyBlue
#property  indicator_color2  DeepSkyBlue
#property  indicator_color3  PaleVioletRed
#property  indicator_color4  PaleVioletRed
#property  indicator_color5  Silver
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2

extern double T3Hot      = 0.7;
extern double T3Short    =  10;
extern double T3Long     =  20;
extern bool   T3Original = false;
extern int    Price      = PRICE_MEDIAN;

//
//
//
//
//

double osc[];
double oscUu[];
double oscUd[];
double oscDd[];
double oscDu[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,oscUu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,oscUd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,oscDd);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,oscDu);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,osc);
   SetIndexBuffer(5,slope);
   IndicatorShortName("T3 - oscillator ("+DoubleToStr(T3Short,2)+","+DoubleToStr(T3Long,2)+","+DoubleToStr(T3Hot,2)+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);


         //
         //
         //
         //
         //

         for (i=limit; i>=0 ; i--)
         {
            double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
               osc[i]   = iT3(price,T3Short,T3Hot,T3Original,i,0)-iT3(price,T3Long,T3Hot,T3Original,i,1);
               oscUu[i] = EMPTY_VALUE;
               oscUd[i] = EMPTY_VALUE;
               oscDu[i] = EMPTY_VALUE;
               oscDd[i] = EMPTY_VALUE;
               slope[i] = slope[i+1];
                  if (osc[i]>osc[i+1]) slope[i] =  1;
                  if (osc[i]<osc[i+1]) slope[i] = -1;
                  if (osc[i]>0)
                     if (slope[i]==1)
                           oscUu[i] = osc[i];
                     else  oscUd[i] = osc[i];
                  if (osc[i]<0)
                     if (slope[i]==-1)
                           oscDd[i] = osc[i];
                     else  oscDu[i] = osc[i];
         }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}