//------------------------------------------------------------------
#property copyright "thefxpros"
#property link      "thefxpros@katamail.com"
//------------------------------------------------------------------


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Orange
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 Orange
#property indicator_width3 1
#property indicator_width4 1


//
//
//

extern int      TimeFrame     = 0;
extern int      Length        = 2;
extern double   Coeff         = 1.75;
extern int      LineWidth     = 1;
extern int      ArrowWidth    = 1;
extern color    UpLineClr     = LimeGreen;
extern color    DnLineClr     = Orange;
extern color    UpArrowClr    = LimeGreen;
extern color    DnArrowClr    = Orange;

//

double WTS[];
double WTSDn[];
double arrUp[];
double arrDn[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,WTS);     SetIndexStyle(0,DRAW_LINE, EMPTY, LineWidth, DnLineClr);
   SetIndexBuffer(1,WTSDn);   SetIndexStyle(1,DRAW_LINE, EMPTY, LineWidth, UpLineClr);
   SetIndexBuffer(2,arrUp);   SetIndexStyle(2,DRAW_ARROW, EMPTY, ArrowWidth, UpArrowClr); SetIndexArrow(2,SYMBOL_ARROWUP);
   SetIndexBuffer(3,arrDn);   SetIndexStyle(3,DRAW_ARROW, EMPTY, ArrowWidth, DnArrowClr); SetIndexArrow(3,SYMBOL_ARROWDOWN);

   
   IndicatorShortName("Wilders trailing stop MTF ("+Length+","+Coeff+")");
      Length = MathMax(Length,1);
      

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("Wilders trailing stop MTF ("+TimeFrameStr+")");
   return(0);

  }

//----

   
 
//+------------------------------------------------------------------+
//| MTF function                                                     |
//+------------------------------------------------------------------+


int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= MathMin(Bars-counted_bars+3*TimeFrame/Period(),Bars-1);
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
   

/*********************************************************************************************************
   Add your main indicator loop below. You can reference an existing indicator with its iName or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 ********************************************************************************************************/ 
  
 
   WTS[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,0,y);
   WTSDn[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,1,y); 
   arrUp[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,2,y);
   arrDn[i]=iCustom(Symbol(),TimeFrame,"Wilders trailing stop",Length,Coeff,3,y);
     
   

   }   
   return(0);
  }
//+------------------------------------------------------------------+